diff --git a/tests/test_datasource.py b/tests/test_datasource.py
index 64329e2e..e40162c0 100644
--- a/tests/test_datasource.py
+++ b/tests/test_datasource.py
@@ -29,12 +29,13 @@ def pub(request):
     req = HTTPRequest(None, {'SCRIPT_NAME': '/', 'SERVER_NAME': 'example.net'})
     pub.set_app_dir(req)
 
-    open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w').write(
-        '''
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        fd.write(
+            '''
 [wscall-secrets]
 api.example.com = 1234
 '''
-    )
+        )
 
     pub.load_site_options()
 
@@ -192,44 +193,38 @@ def test_json_datasource(pub, requests_pub, http_requests):
 
     # invalid json file
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'wb')
-    json_file.write(codecs.encode(b'foobar', 'zlib_codec'))
-    json_file.close()
+    with open(json_file_path, 'wb') as json_file:
+        json_file.write(codecs.encode(b'foobar', 'zlib_codec'))
     assert data_sources.get_items(datasource) == []
 
     # empty json file
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({}, json_file)
     assert data_sources.get_items(datasource) == []
 
     # unrelated json file
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump('foobar', json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump('foobar', json_file)
     assert data_sources.get_items(datasource) == []
 
     # another unrelated json file
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': 'foobar'}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': 'foobar'}, json_file)
     assert data_sources.get_items(datasource) == []
 
     # json file not using dictionaries
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': [['1', 'foo'], ['2', 'bar']]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': [['1', 'foo'], ['2', 'bar']]}, json_file)
     assert data_sources.get_items(datasource) == []
 
     # a good json file
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': [{'id': '1', 'text': 'foo'}, {'id': '2', 'text': 'bar'}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': [{'id': '1', 'text': 'foo'}, {'id': '2', 'text': 'bar'}]}, json_file)
     assert data_sources.get_items(datasource) == [
         ('1', 'foo', '1', {'id': '1', 'text': 'foo'}),
         ('2', 'bar', '2', {'id': '2', 'text': 'bar'}),
@@ -241,12 +236,11 @@ def test_json_datasource(pub, requests_pub, http_requests):
 
     # a json file with additional keys
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump(
-        {'data': [{'id': '1', 'text': 'foo', 'more': 'xxx'}, {'id': '2', 'text': 'bar', 'more': 'yyy'}]},
-        json_file,
-    )
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump(
+            {'data': [{'id': '1', 'text': 'foo', 'more': 'xxx'}, {'id': '2', 'text': 'bar', 'more': 'yyy'}]},
+            json_file,
+        )
     assert data_sources.get_items(datasource) == [
         ('1', 'foo', '1', {'id': '1', 'text': 'foo', 'more': 'xxx'}),
         ('2', 'bar', '2', {'id': '2', 'text': 'bar', 'more': 'yyy'}),
@@ -299,9 +293,8 @@ def test_json_datasource(pub, requests_pub, http_requests):
 
     # a json file with integer as 'id'
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': [{'id': 1, 'text': 'foo'}, {'id': 2, 'text': 'bar'}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': [{'id': 1, 'text': 'foo'}, {'id': 2, 'text': 'bar'}]}, json_file)
     assert data_sources.get_items(datasource) == [
         ('1', 'foo', '1', {'id': 1, 'text': 'foo'}),
         ('2', 'bar', '2', {'id': 2, 'text': 'bar'}),
@@ -313,9 +306,8 @@ def test_json_datasource(pub, requests_pub, http_requests):
 
     # a json file with empty or no text values
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': [{'id': '1', 'text': ''}, {'id': '2'}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': [{'id': '1', 'text': ''}, {'id': '2'}]}, json_file)
     assert data_sources.get_items(datasource) == [
         ('1', '', '1', {'id': '1', 'text': ''}),
         ('2', '2', '2', {'id': '2', 'text': '2'}),
@@ -327,18 +319,16 @@ def test_json_datasource(pub, requests_pub, http_requests):
 
     # a json file with empty or no id
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': [{'id': '', 'text': 'foo'}, {'text': 'bar'}, {'id': None}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': [{'id': '', 'text': 'foo'}, {'text': 'bar'}, {'id': None}]}, json_file)
     assert data_sources.get_items(datasource) == []
     assert data_sources.get_structured_items(datasource) == []
 
     # specify data_attribute
     datasource = {'type': 'json', 'value': ' {{ json_url }}', 'data_attribute': 'results'}
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'results': [{'id': '1', 'text': 'foo'}, {'id': '2', 'text': 'bar'}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'results': [{'id': '1', 'text': 'foo'}, {'id': '2', 'text': 'bar'}]}, json_file)
     assert data_sources.get_structured_items(datasource) == [
         {'id': '1', 'text': 'foo'},
         {'id': '2', 'text': 'bar'},
@@ -351,9 +341,8 @@ def test_json_datasource(pub, requests_pub, http_requests):
     # specify id_attribute
     datasource = {'type': 'json', 'value': ' {{ json_url }}', 'id_attribute': 'pk'}
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': [{'pk': '1', 'text': 'foo'}, {'pk': '2', 'text': 'bar'}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': [{'pk': '1', 'text': 'foo'}, {'pk': '2', 'text': 'bar'}]}, json_file)
     assert data_sources.get_structured_items(datasource) == [
         {'id': '1', 'text': 'foo', 'pk': '1'},
         {'id': '2', 'text': 'bar', 'pk': '2'},
@@ -366,9 +355,8 @@ def test_json_datasource(pub, requests_pub, http_requests):
     # specify text_attribute
     datasource = {'type': 'json', 'value': ' {{ json_url }}', 'text_attribute': 'label'}
     get_request().datasources_cache = {}
-    json_file = open(json_file_path, 'w')
-    json.dump({'data': [{'id': '1', 'label': 'foo'}, {'id': '2', 'label': 'bar'}]}, json_file)
-    json_file.close()
+    with open(json_file_path, 'w') as json_file:
+        json.dump({'data': [{'id': '1', 'label': 'foo'}, {'id': '2', 'label': 'bar'}]}, json_file)
     assert data_sources.get_structured_items(datasource) == [
         {'id': '1', 'text': 'foo', 'label': 'foo'},
         {'id': '2', 'text': 'bar', 'label': 'bar'},
@@ -508,45 +496,40 @@ def test_geojson_datasource(pub, requests_pub, http_requests):
 
     # invalid geojson file
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'wb')
-    geojson_file.write(codecs.encode(b'foobar', 'zlib_codec'))
-    geojson_file.close()
+    with open(geojson_file_path, 'wb') as geojson_file:
+        geojson_file.write(codecs.encode(b'foobar', 'zlib_codec'))
     assert data_sources.get_items(datasource) == []
 
     # empty geojson file
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump({}, geojson_file)
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump({}, geojson_file)
     assert data_sources.get_items(datasource) == []
 
     # unrelated geojson file
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump('foobar', geojson_file)
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump('foobar', geojson_file)
     assert data_sources.get_items(datasource) == []
 
     # another unrelated geojson file
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump({'features': 'foobar'}, geojson_file)
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump({'features': 'foobar'}, geojson_file)
     assert data_sources.get_items(datasource) == []
 
     # a good geojson file
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {
-            'features': [
-                {'properties': {'id': '1', 'text': 'foo'}},
-                {'properties': {'id': '2', 'text': 'bar'}},
-            ]
-        },
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'properties': {'id': '1', 'text': 'foo'}},
+                    {'properties': {'id': '2', 'text': 'bar'}},
+                ]
+            },
+            geojson_file,
+        )
     assert data_sources.get_items(datasource) == [
         ('1', 'foo', '1', {'id': '1', 'text': 'foo', 'properties': {'id': '1', 'text': 'foo'}}),
         ('2', 'bar', '2', {'id': '2', 'text': 'bar', 'properties': {'id': '2', 'text': 'bar'}}),
@@ -558,17 +541,16 @@ def test_geojson_datasource(pub, requests_pub, http_requests):
 
     # a geojson file with additional keys
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {
-            'features': [
-                {'properties': {'id': '1', 'text': 'foo', 'more': 'xxx'}},
-                {'properties': {'id': '2', 'text': 'bar', 'more': 'yyy'}},
-            ]
-        },
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'properties': {'id': '1', 'text': 'foo', 'more': 'xxx'}},
+                    {'properties': {'id': '2', 'text': 'bar', 'more': 'yyy'}},
+                ]
+            },
+            geojson_file,
+        )
     assert data_sources.get_items(datasource) == [
         (
             '1',
@@ -671,12 +653,16 @@ def test_geojson_datasource(pub, requests_pub, http_requests):
 
     # a geojson file with integer as 'id'
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {'features': [{'properties': {'id': 1, 'text': 'foo'}}, {'properties': {'id': 2, 'text': 'bar'}}]},
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'properties': {'id': 1, 'text': 'foo'}},
+                    {'properties': {'id': 2, 'text': 'bar'}},
+                ]
+            },
+            geojson_file,
+        )
     assert data_sources.get_items(datasource) == [
         ('1', 'foo', '1', {'id': 1, 'text': 'foo', 'properties': {'id': 1, 'text': 'foo'}}),
         ('2', 'bar', '2', {'id': 2, 'text': 'bar', 'properties': {'id': 2, 'text': 'bar'}}),
@@ -688,11 +674,10 @@ def test_geojson_datasource(pub, requests_pub, http_requests):
 
     # a geojson file with empty or no text values
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {'features': [{'properties': {'id': '1', 'text': ''}}, {'properties': {'id': '2'}}]}, geojson_file
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {'features': [{'properties': {'id': '1', 'text': ''}}, {'properties': {'id': '2'}}]}, geojson_file
+        )
     assert data_sources.get_items(datasource) == [
         ('1', '1', '1', {'id': '1', 'text': '1', 'properties': {'id': '1', 'text': ''}}),
         ('2', '2', '2', {'id': '2', 'text': '2', 'properties': {'id': '2'}}),
@@ -704,35 +689,33 @@ def test_geojson_datasource(pub, requests_pub, http_requests):
 
     # a geojson file with empty or no id
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {
-            'features': [
-                {'properties': {'id': '', 'text': 'foo'}},
-                {'properties': {'text': 'bar'}},
-                {'properties': {'id': None}},
-            ]
-        },
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'properties': {'id': '', 'text': 'foo'}},
+                    {'properties': {'text': 'bar'}},
+                    {'properties': {'id': None}},
+                ]
+            },
+            geojson_file,
+        )
     assert data_sources.get_items(datasource) == []
     assert data_sources.get_structured_items(datasource) == []
 
     # specify id_property
     datasource = {'type': 'geojson', 'value': ' {{ geojson_url }}', 'id_property': 'gid'}
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {
-            'features': [
-                {'properties': {'gid': '1', 'text': 'foo'}},
-                {'properties': {'gid': '2', 'text': 'bar'}},
-            ]
-        },
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'properties': {'gid': '1', 'text': 'foo'}},
+                    {'properties': {'gid': '2', 'text': 'bar'}},
+                ]
+            },
+            geojson_file,
+        )
     assert data_sources.get_structured_items(datasource) == [
         {'id': '1', 'text': 'foo', 'properties': {'gid': '1', 'text': 'foo'}},
         {'id': '2', 'text': 'bar', 'properties': {'gid': '2', 'text': 'bar'}},
@@ -745,17 +728,16 @@ def test_geojson_datasource(pub, requests_pub, http_requests):
 
     # check with feature IDs
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {
-            'features': [
-                {'id': '1', 'properties': {'text': 'foo'}},
-                {'id': '2', 'properties': {'text': 'bar'}},
-            ]
-        },
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'id': '1', 'properties': {'text': 'foo'}},
+                    {'id': '2', 'properties': {'text': 'bar'}},
+                ]
+            },
+            geojson_file,
+        )
     assert data_sources.get_structured_items(datasource) == [
         {'id': '1', 'text': 'foo', 'properties': {'text': 'foo'}},
         {'id': '2', 'text': 'bar', 'properties': {'text': 'bar'}},
@@ -768,17 +750,16 @@ def test_geojson_datasource(pub, requests_pub, http_requests):
         'label_template_property': '{{ id }}: {{ text }}',
     }
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {
-            'features': [
-                {'properties': {'id': '1', 'text': 'foo'}},
-                {'properties': {'id': '2', 'text': 'bar'}},
-            ]
-        },
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'properties': {'id': '1', 'text': 'foo'}},
+                    {'properties': {'id': '2', 'text': 'bar'}},
+                ]
+            },
+            geojson_file,
+        )
     assert data_sources.get_structured_items(datasource) == [
         {'id': '1', 'text': '1: foo', 'properties': {'id': '1', 'text': 'foo'}},
         {'id': '2', 'text': '2: bar', 'properties': {'id': '2', 'text': 'bar'}},
@@ -801,17 +782,16 @@ def test_geojson_datasource(pub, requests_pub, http_requests):
     # unknown property or empty value
     datasource = {'type': 'geojson', 'value': ' {{ geojson_url }}', 'label_template_property': '{{ label }}'}
     get_request().datasources_cache = {}
-    geojson_file = open(geojson_file_path, 'w')
-    json.dump(
-        {
-            'features': [
-                {'properties': {'id': '1', 'text': 'foo', 'label': ''}},
-                {'properties': {'id': '2', 'text': 'bar'}},
-            ]
-        },
-        geojson_file,
-    )
-    geojson_file.close()
+    with open(geojson_file_path, 'w') as geojson_file:
+        json.dump(
+            {
+                'features': [
+                    {'properties': {'id': '1', 'text': 'foo', 'label': ''}},
+                    {'properties': {'id': '2', 'text': 'bar'}},
+                ]
+            },
+            geojson_file,
+        )
     assert data_sources.get_structured_items(datasource) == [
         {'id': '1', 'text': '1', 'properties': {'id': '1', 'text': 'foo', 'label': ''}},
         {'id': '2', 'text': '2', 'properties': {'id': '2', 'text': 'bar'}},
diff --git a/tests/test_ezt.py b/tests/test_ezt.py
index 1cf2b288..07470933 100644
--- a/tests/test_ezt.py
+++ b/tests/test_ezt.py
@@ -217,9 +217,8 @@ def test_dict_index():
 
 def test_ezt_script(pub):
     os.mkdir(os.path.join(pub.app_dir, 'scripts'))
-    fd = open(os.path.join(pub.app_dir, 'scripts', 'hello_world.py'), 'w')
-    fd.write('''result = "Hello %s" % ("world" if not args else args[0])''')
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'scripts', 'hello_world.py'), 'w') as fd:
+        fd.write('''result = "Hello %s" % ("world" if not args else args[0])''')
 
     vars = {'script': ScriptsSubstitutionProxy()}
     template = Template()
diff --git a/tests/test_hobo.py b/tests/test_hobo.py
index 93711c23..1fbe606d 100644
--- a/tests/test_hobo.py
+++ b/tests/test_hobo.py
@@ -375,11 +375,10 @@ def test_configure_authentication_methods(http_requests):
 def test_deploy():
     cleanup()
     WcsPublisher.APP_DIR = alt_tempdir
-    fd = open(os.path.join(alt_tempdir, 'hobo.json'), 'w')
-    hobo_json = copy.deepcopy(HOBO_JSON)
-    del hobo_json['services'][1]  # authentic
-    fd.write(json.dumps(HOBO_JSON))
-    fd.close()
+    with open(os.path.join(alt_tempdir, 'hobo.json'), 'w') as fd:
+        hobo_json = copy.deepcopy(HOBO_JSON)
+        del hobo_json['services'][1]  # authentic
+        fd.write(json.dumps(HOBO_JSON))
     hobo_cmd = CmdCheckHobos()
     base_options = {}
     sub_options_class = collections.namedtuple('Options', ['ignore_timestamp', 'redeploy', 'extra'])
@@ -406,11 +405,10 @@ def test_deploy():
 def test_configure_postgresql():
     cleanup()
     WcsPublisher.APP_DIR = alt_tempdir
-    fd = open(os.path.join(alt_tempdir, 'hobo.json'), 'w')
-    hobo_json = copy.deepcopy(HOBO_JSON)
-    del hobo_json['services'][1]  # authentic
-    fd.write(json.dumps(HOBO_JSON))
-    fd.close()
+    with open(os.path.join(alt_tempdir, 'hobo.json'), 'w') as fd:
+        hobo_json = copy.deepcopy(HOBO_JSON)
+        del hobo_json['services'][1]  # authentic
+        fd.write(json.dumps(HOBO_JSON))
 
     service = [x for x in HOBO_JSON.get('services', []) if x.get('service-id') == 'wcs'][0]
 
@@ -424,10 +422,9 @@ def test_configure_postgresql():
     )
     assert os.path.exists(os.path.join(alt_tempdir, 'wcs.example.net'))
 
-    fd = open(os.path.join(alt_tempdir, 'wcs.example.net', 'site-options.cfg'), 'w')
-    fd.write('[options]\n')
-    fd.write('postgresql = true\n')
-    fd.close()
+    with open(os.path.join(alt_tempdir, 'wcs.example.net', 'site-options.cfg'), 'w') as fd:
+        fd.write('[options]\n')
+        fd.write('postgresql = true\n')
 
     cleanup()
 
diff --git a/tests/test_misc.py b/tests/test_misc.py
index 3e41a593..5b985033 100644
--- a/tests/test_misc.py
+++ b/tests/test_misc.py
@@ -209,25 +209,22 @@ def test_script_substitution_variable():
         assert variables['script'].hello_world()
 
     os.mkdir(os.path.join(pub.app_dir, 'scripts'))
-    fd = open(os.path.join(pub.app_dir, 'scripts', 'hello_world.py'), 'w')
-    fd.write('"""docstring"""\nresult = "hello world"')
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'scripts', 'hello_world.py'), 'w') as fd:
+        fd.write('"""docstring"""\nresult = "hello world"')
     assert variables['script'].hello_world() == 'hello world'
 
     assert Script('hello_world').__doc__ == 'docstring'
 
     os.mkdir(os.path.join(pub.APP_DIR, 'scripts'))
-    fd = open(os.path.join(pub.APP_DIR, 'scripts', 'hello_world.py'), 'w')
-    fd.write('result = "hello global world"')
-    fd.close()
+    with open(os.path.join(pub.APP_DIR, 'scripts', 'hello_world.py'), 'w') as fd:
+        fd.write('result = "hello global world"')
     assert variables['script'].hello_world() == 'hello world'
 
     os.unlink(os.path.join(pub.app_dir, 'scripts', 'hello_world.py'))
     assert variables['script'].hello_world() == 'hello global world'
 
-    fd = open(os.path.join(pub.app_dir, 'scripts', 'hello_world.py'), 'w')
-    fd.write('result = site_url')
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'scripts', 'hello_world.py'), 'w') as fd:
+        fd.write('result = site_url')
     assert variables['script'].hello_world() == 'http://example.net'
 
 
@@ -404,9 +401,8 @@ def test_pagination():
     if not pub.site_options.has_section('options'):
         pub.site_options.add_section('options')
     pub.site_options.set('options', 'default-page-size', '500')
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    pub.site_options.write(fd)
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        pub.site_options.write(fd)
     assert '(1-101/1000)' in get_texts(pagination_links(0, 101, 1000))
     assert '(1-500/1000)' in get_texts(pagination_links(0, 500, 1000))
     assert '(1-500/1000)' in get_texts(pagination_links(0, 501, 1000))  # 500 is the max
@@ -705,32 +701,34 @@ def test_related_field_repr():
 def test_find_vc_version():
     import wcs.qommon.admin.menu
 
-    with mock.patch('os.path.exists') as os_path_exists, mock.patch('subprocess.Popen') as popen:
-
-        def mocked_os_path_exists(path):
-            return bool(not path.endswith('setup.py'))
-
-        os_path_exists.side_effect = mocked_os_path_exists
-
-        def mocked_popen(*args, **kwargs):
-            class Process:
-                returncode = 0
+    def mocked_popen(*args, **kwargs):
+        class Process:
+            returncode = 0
 
-                def communicate(self):
-                    return (
-                        b'''Desired=Unknown/Install/Remove/Purge/Hold
+            def communicate(self):
+                return (
+                    b'''Desired=Unknown/Install/Remove/Purge/Hold
 | Status=Not/Inst/Conf-files/Unpacked/halF-conf/Half-inst/trig-aWait/Trig-pend
 |/ Err?=(none)/Reinst-required (Status,Err: uppercase=bad)
 ||/ Name           Version         Architecture Description
 +++-==============-===============-============-=================================================
 ii  wcs            5.71-1~eob100+1 all          web application to design and set up online forms
 ''',
-                        '',
-                    )
+                    '',
+                )
 
-            return Process()
+        return Process()
+
+    with mock.patch('os.path.exists') as os_path_exists, mock.patch('subprocess.Popen') as popen:
+
+        def mocked_os_path_exists(path):
+            return bool(not path.endswith('setup.py'))
+
+        os_path_exists.side_effect = mocked_os_path_exists
 
-        popen.side_effect = mocked_popen
+        handle = mock.MagicMock()
+        handle.__enter__.side_effect = mocked_popen
+        popen.return_value = handle
 
         version = wcs.qommon.admin.menu._find_vc_version()
         assert version == 'wcs 5.71-1~eob100+1 (Debian)'
diff --git a/tests/test_publisher.py b/tests/test_publisher.py
index c9659b2d..b7a81b38 100644
--- a/tests/test_publisher.py
+++ b/tests/test_publisher.py
@@ -177,9 +177,8 @@ def test_import_config_zip():
     pub.write_cfg()
 
     c = io.BytesIO()
-    z = zipfile.ZipFile(c, 'w')
-    z.writestr('config.pck', pickle.dumps({'language': {'language': 'fr'}, 'whatever': ['a', 'b', 'c']}))
-    z.close()
+    with zipfile.ZipFile(c, 'w') as z:
+        z.writestr('config.pck', pickle.dumps({'language': {'language': 'fr'}, 'whatever': ['a', 'b', 'c']}))
     c.seek(0)
 
     pub.import_zip(c)
@@ -188,11 +187,10 @@ def test_import_config_zip():
     assert pub.cfg['sp'] == {'what': 'ever'}
 
     c = io.BytesIO()
-    z = zipfile.ZipFile(c, 'w')
-    z.writestr(
-        'config.json', json.dumps({'language': {'language': 'en'}, 'whatever2': ['a', 'b', {'c': 'd'}]})
-    )
-    z.close()
+    with zipfile.ZipFile(c, 'w') as z:
+        z.writestr(
+            'config.json', json.dumps({'language': {'language': 'en'}, 'whatever2': ['a', 'b', {'c': 'd'}]})
+        )
     c.seek(0)
 
     pub.import_zip(c)
diff --git a/tests/test_saml_auth.py b/tests/test_saml_auth.py
index 6de1f827..fa49df00 100644
--- a/tests/test_saml_auth.py
+++ b/tests/test_saml_auth.py
@@ -81,19 +81,16 @@ def setup_idps(pub, idp_number=1):
             'role': lasso.PROVIDER_ROLE_IDP,
         }
         filename = pub.cfg['idp'][base_id]['metadata']
-        fd = open(os.path.join(pub.app_dir, filename), 'w')
-        fd.write(metadata)
-        fd.close()
+        with open(os.path.join(pub.app_dir, filename), 'w') as fd:
+            fd.write(metadata)
 
         filename = pub.cfg['idp'][base_id]['publickey']
-        fd = open(os.path.join(pub.app_dir, filename), 'w')
-        fd.write(idp_publickey)
-        fd.close()
+        with open(os.path.join(pub.app_dir, filename), 'w') as fd:
+            fd.write(idp_publickey)
 
         filename = pub.cfg['idp'][base_id]['publickey'].replace('public', 'private')
-        fd = open(os.path.join(pub.app_dir, filename), 'w')
-        fd.write(idp_privatekey)
-        fd.close()
+        with open(os.path.join(pub.app_dir, filename), 'w') as fd:
+            fd.write(idp_privatekey)
 
     pub.write_cfg()
 
diff --git a/tests/test_workflows.py b/tests/test_workflows.py
index 65f9163a..9a9469ce 100644
--- a/tests/test_workflows.py
+++ b/tests/test_workflows.py
@@ -3506,8 +3506,8 @@ def test_export_to_model_image(pub):
     item.perform(formdata)
 
     assert formdata.evolution[-1].parts[-1].base_filename == 'template.odt'
-    zfile = zipfile.ZipFile(formdata.evolution[-1].parts[0].filename, mode='r')
-    zinfo = zfile.getinfo('Pictures/10000000000000320000003276E9D46581B55C88.jpg')
+    with zipfile.ZipFile(formdata.evolution[-1].parts[0].filename, mode='r') as zfile:
+        zinfo = zfile.getinfo('Pictures/10000000000000320000003276E9D46581B55C88.jpg')
     # check the image has been replaced by the one from the formdata
     assert zinfo.file_size == len(image_data)
 
@@ -3521,8 +3521,8 @@ def test_export_to_model_image(pub):
 
         item.perform(formdata)
 
-        zfile = zipfile.ZipFile(formdata.evolution[-1].parts[0].filename, mode='r')
-        zinfo = zfile.getinfo('Pictures/10000000000000320000003276E9D46581B55C88.jpg')
+        with zipfile.ZipFile(formdata.evolution[-1].parts[0].filename, mode='r') as zfile:
+            zinfo = zfile.getinfo('Pictures/10000000000000320000003276E9D46581B55C88.jpg')
         # check the original image has been left
         assert zinfo.file_size == 580
 
@@ -3574,8 +3574,8 @@ def test_export_to_model_backoffice_field(pub):
     fbo1 = formdata.data['bo1']
     assert fbo1.base_filename == 'template.odt'
     assert fbo1.content_type == 'application/octet-stream'
-    zfile = zipfile.ZipFile(fbo1.get_file())
-    assert b'foo-export-to-bofile' in zfile.read('content.xml')
+    with zipfile.ZipFile(fbo1.get_file()) as zfile:
+        assert b'foo-export-to-bofile' in zfile.read('content.xml')
 
     # no more 'bo1' backoffice field: do nothing
     formdata = formdef.data_class()()
diff --git a/tests/utilities.py b/tests/utilities.py
index f1dcb949..00fd23cf 100644
--- a/tests/utilities.py
+++ b/tests/utilities.py
@@ -108,19 +108,18 @@ def create_temporary_pub(sql_mode=False, templates_mode=False, lazy_mode=False):
         created = True
 
     # always reset site-options.cfg
-    fd = open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w')
-    fd.write('[wscall-secrets]\n')
-    fd.write('idp.example.net = BAR\n')
-    fd.write('\n')
-    fd.write('[options]\n')
-    fd.write('formdef-captcha-option = true\n')
-    fd.write('formdef-appearance-keywords = true\n')
-    fd.write('workflow-resubmit-action = true\n')
-    if lazy_mode:
-        fd.write('force-lazy-mode = true\n')
-    if sql_mode:
-        fd.write('postgresql = true\n')
-    fd.close()
+    with open(os.path.join(pub.app_dir, 'site-options.cfg'), 'w') as fd:
+        fd.write('[wscall-secrets]\n')
+        fd.write('idp.example.net = BAR\n')
+        fd.write('\n')
+        fd.write('[options]\n')
+        fd.write('formdef-captcha-option = true\n')
+        fd.write('formdef-appearance-keywords = true\n')
+        fd.write('workflow-resubmit-action = true\n')
+        if lazy_mode:
+            fd.write('force-lazy-mode = true\n')
+        if sql_mode:
+            fd.write('postgresql = true\n')
 
     # make sure site options are not cached
     pub.site_options = None
diff --git a/wcs/admin/forms.py b/wcs/admin/forms.py
index 3563d4e4..a88b1774 100644
--- a/wcs/admin/forms.py
+++ b/wcs/admin/forms.py
@@ -1519,11 +1519,13 @@ class FormDefPage(Directory):
                     all_forms = [x for x in all_forms if x.last_update_time < date]
 
                 self.fd = io.BytesIO()
-                t = tarfile.open('wcs.tar.gz', 'w:gz', fileobj=self.fd)
-                t.add(self.formdef.get_object_filename(), 'formdef')
-                for formdata in all_forms:
-                    t.add(formdata.get_object_filename(), '%s/%s' % (self.formdef.url_name, str(formdata.id)))
-                t.close()
+                with tarfile.open('wcs.tar.gz', 'w:gz', fileobj=self.fd) as t:
+                    t.add(self.formdef.get_object_filename(), 'formdef')
+                    for formdata in all_forms:
+                        t.add(
+                            formdata.get_object_filename(),
+                            '%s/%s' % (self.formdef.url_name, str(formdata.id)),
+                        )
 
                 if form.get_widget('keep').parse() is False:
                     for f in all_forms:
